Mantis Bug Tracker

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0006466OCamlOCaml generalpublic2014-06-20 01:222014-12-19 04:18
Reporterwhitequark 
Assigned Togarrigue 
PrioritynormalSeveritytextReproducibilityalways
StatusassignedResolutionreopened 
PlatformOSOS Version
Product Version4.02.0+beta1 / +rc1 
Target Version4.02.2+devFixed in Version4.02.1+dev 
Summary0006466: Non-exhaustive matching warning message for open types is confusing
DescriptionHere it is:

    Warning 8: this pattern-matching is not exhaustive.
    Here is an example of a value that is not matched:
    *extension*

I scratched my head for quite a while before I got it.
Steps To Reproduce    function Not_found -> ()
TagsNo tags attached.
Attached Filespatch file icon open-types-msg.patch [^] (1,326 bytes) 2014-12-19 04:18 [Show Content]

- Relationships

-  Notes
(0011833)
doligez (administrator)
2014-07-16 10:31

Let's have a discussion of what the error message should look like.
(0012125)
whitequark (developer)
2014-09-14 22:40

Warning 8: this pattern-matching is not exhaustive.
    Matching over values of open types must include
    a wildcard pattern in order to be exhaustive.
(0012126)
garrigue (manager)
2014-09-15 05:04

Fixed as suggested.
The warning is now:

Warning 8: this pattern-matching is not exhaustive.
Here is an example of a value that is not matched:
_
Matching over values of open types must include
a wild card pattern in order to be exhaustive.

Removing the 2nd and 3rd line would require changing the warning definition.
(0012132)
lpw25 (developer)
2014-09-15 11:01

For consistency with the documentation, could we change:

    Matching over values of open types must include
    a wild card pattern in order to be exhaustive.

to

    Matching over values of extensible variant types must include
    a wild card pattern in order to be exhaustive.
(0012379)
doligez (administrator)
2014-10-15 14:41

Reopened: let us discuss (or implement) Leo's proposed change to the warning message.
(0012878)
whitequark (developer)
2014-12-19 03:59

Reminder sent to: gasche

gasche, can you please apply the trivial fix listed in the issue?

- Issue History
Date Modified Username Field Change
2014-06-20 01:22 whitequark New Issue
2014-07-16 10:31 doligez Note Added: 0011833
2014-07-16 10:31 doligez Severity minor => text
2014-07-16 10:31 doligez Status new => acknowledged
2014-07-16 10:31 doligez Target Version => 4.02.1+dev
2014-09-04 00:25 doligez Target Version 4.02.1+dev => undecided
2014-09-14 22:34 doligez Status acknowledged => feedback
2014-09-14 22:34 doligez Target Version undecided => 4.02.2+dev
2014-09-14 22:40 whitequark Note Added: 0012125
2014-09-14 22:40 whitequark Status feedback => new
2014-09-15 05:04 garrigue Note Added: 0012126
2014-09-15 05:04 garrigue Status new => resolved
2014-09-15 05:04 garrigue Fixed in Version => 4.02.1+dev
2014-09-15 05:04 garrigue Resolution open => fixed
2014-09-15 05:04 garrigue Assigned To => garrigue
2014-09-15 11:01 lpw25 Note Added: 0012132
2014-10-15 14:41 doligez Note Added: 0012379
2014-10-15 14:41 doligez Status resolved => feedback
2014-10-15 14:41 doligez Resolution fixed => reopened
2014-12-19 03:59 whitequark Note Added: 0012878
2014-12-19 03:59 whitequark Status feedback => assigned
2014-12-19 04:18 whitequark File Added: open-types-msg.patch


Copyright © 2000 - 2011 MantisBT Group
Powered by Mantis Bugtracker